//<c>   Copyright 1993-1999 by Gerry J. Danen; all rights reserved.

//<t>   Show Network Bulletins


#define IS_SHOWBULL
#include"nss.h"


static  UCHAR   cmd[256] ;
static  ULONG   userID ;


#include"nss.ccc"


void    show_bulletins( STRING bull_dir, STRING mailbull_file )
{
    BOOL        is_net_drive, ynSavedScreen=FALSE ;
    INT16       drive, bull_drv=-1, mail_drv=-1 ;
    UCHAR       drv, bullspec[9] ;
    int         fh ;
    unsigned    lread_date, lread_time, lr_date, lr_time, un ;
    struct _find_t bul ;

    LOOP( drive, 4, 26, 1 )
    {
        is_net_drive = dr_is_networked( (UCHAR) drive );
        if ( is_net_drive && dr_is_cdrom( (UCHAR) drive ) )
            is_net_drive = FALSE ;
        if ( is_net_drive && ! ValidDrive( drive-1 ) )
        {
            if ( bull_drv < 0 )
                bull_drv = drive ;
        }
    }
    if ( bull_drv < 0 )
    {
        ErrMsg( "No free drives to map to bulletin directory" );
        return ;
    }
    drv = bull_drv + '@' ;
    if ( nw_map_fakeroot( drv, bull_dir ) )
    {
        ErrMsg( "Bulletin directory does not exist" );
        return ;
    }
    if ( _dos_open( mailbull_file, _O_RDONLY, &fh ) != 0 )  // not found
    {
        lread_date = lread_time = 0 ;
    }
    else
    {
        _dos_getftime( fh, &lread_date, &lread_time );
        _dos_close( fh );
    }

    lr_date = lread_date ;
    lr_time = lread_time ;
    sprintf( bullspec, "%c:*.bul", drv );
    if ( _dos_findfirst( bullspec, _A_NORMAL, &bul ) == 0 )
    {
        do  {
            if ((bul.wr_date > lread_date) ||
                (bul.wr_date == lread_date && bul.wr_time > lread_time) )
            {
                sprintf( cmd, "%c:%s", drv, bul.name );
                if ( ! ynSavedScreen )
                {
                    sc_save_video_state();
                    cls();
                    ynSavedScreen = TRUE ;
                }
                fl_view_init( sc_vid_rows()-2, sc_vid_cols()/2+1, 1, "Network Bulletin", NO );
                fl_view_a_file( cmd, NO );
                fl_view_exit();
                if ((bul.wr_date > lr_date) ||
                    (bul.wr_date == lr_date && bul.wr_time > lr_time) )
                {
                    lr_date = bul.wr_date ;
                    lr_time = bul.wr_time ;
                }
            }
        }   while( _dos_findnext( &bul ) == 0 );
        if ( ynSavedScreen )
            sc_restore_video_state();
    }

    fl_delete ( mailbull_file );
    _dos_creat( mailbull_file, _A_NORMAL, &fh );
    _dos_write( fh, "?", 1, &un );
    _dos_setftime( fh, lr_date, lr_time );
    _dos_close( fh );

    nw_del_drive_mapping( drv );                // don't need this mapping anymore
}


void    main_exit( void )
{
    if ( finish_off_code == BAD_EXIT )
        fprintf( stderr, "Aborting program %s\n", get_global_program_name() );
    fcloseall();
    CursOn();
}


void    main( int argc, char *argv[] )
{
    fs_init( FALSE, SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    Allow_No_Break();                           // allow no ^Break to abort
    atexit( main_exit );

    if ( ! nw_installed_NetWare() )
        abort_job( 1, "Not logged in to a NetWare file server!\n" );

    if ( argc != 3 )
    {
        ErrMsg( "Syntax:  SHOWBULL bulletin_dir lastread_loc_n_file" );
        happy_ending();
    }

    show_bulletins( argv[1], argv[2] );

    happy_ending();
}
